/****************************************************************************

    AstroMenace
    Hardcore 3D space scroll-shooter with spaceship upgrade possibilities.
    Copyright (c) 2006-2019 Mikhail Kurinnoi, Viewizard


    AstroMenace is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    AstroMenace is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AstroMenace. If not, see <https://www.gnu.org/licenses/>.


    Website: https://viewizard.com/
    Project: https://github.com/viewizard/astromenace
    E-mail: viewizard@viewizard.com

*****************************************************************************/

#ifndef CORE_CORE_H
#define CORE_CORE_H

#include "audio/audio.h"
#include "camera/camera.h"
#include "collision_detection/collision_detection.h"
#include "font/font.h"
#include "graphics/graphics.h"
#include "light/light.h"
#include "math/math.h"
#include "model3d/model3d.h"
#include "particle_system/particle_system.h"
#include "particle_system2d/particle_system2d.h"
#include "platform/platform.h"
#include "text/text.h"
#include "texture/texture.h"
#include "time_thread/time_thread.h"
#include "vfs/vfs.h"
#include "xml/xml.h"

#endif // CORE_CORE_H
